[build-system]
requires = [
    "hatchling",
    "jupyterlab>=4.0.0,<5",
    "hatch-nodejs-version",
]
build-backend = "hatchling.build"

[project]
name = "jupyterlab_dashboard_apps"
readme = "README.md"
requires-python = ">=3.8"
classifiers = [
    "Framework :: Jupyter",
    "License :: OSI Approved :: Apache Software License",
    "Operating System :: MacOS :: MacOS X",
    "Operating System :: POSIX :: Linux",
    "Programming Language :: Python",
    "Programming Language :: Python :: 3",
    "Programming Language :: Python :: 3.8",
    "Programming Language :: Python :: 3.9",
    "Programming Language :: Python :: 3.10",
    "Programming Language :: Python :: 3.11",
]
dependencies = [
    "jupyterlab>=4.0.0,<5",
]
dynamic = ["version", "authors", "urls", "keywords", "description", "license"]

[tool.hatch.version]
source = "nodejs"
path = "package.json"

[tool.hatch.metadata.hooks.nodejs]
path = "package.json"
fields = ["authors", "urls"]

[tool.hatch.build]
artifacts = [
    "jupyterlab_dashboard_apps/labextension/",
]

[tool.hatch.build.targets.wheel]
packages = ["jupyterlab_dashboard_apps"]

[tool.hatch.build.targets.wheel.shared-data]
"jupyterlab_dashboard_apps/labextension" = "share/jupyter/labextensions/@idriscnrs/dashboard-apps"
"install.json" = "share/jupyter/labextensions/@idriscnrs/dashboard-apps/install.json"

[tool.hatch.build.targets.sdist]
exclude = [
    ".github",
]

[tool.hatch.build.hooks.jupyter-builder]
ensured-targets = [
    "jupyterlab_dashboard_apps/labextension/package.json",
]
skip-if-exists = [
    "jupyterlab_dashboard_apps/labextension/package.json",
]
dependencies = [
    "hatch-jupyter-builder>=0.8.2",
]
build-function = "hatch_jupyter_builder.npm_builder"
optional-editable-build = true

[tool.hatch.build.hooks.jupyter-builder.build-kwargs]
path = "."
build_cmd = "build:prod"
editable_build_cmd = "build"
npm = [
    "jlpm",
]
